Mesh Scripting/es: Difference between revisions

From FreeCAD Documentation
m (→‎Ajustes y pruebas: Template fr)
(Updating to match new version of source page)
Line 1: Line 1:
=== Introducción ===
=== Introduction ===
First of all you have to import the Mesh module:
<syntaxhighlight>
import Mesh
</syntaxhighlight>
After that you have access to the Mesh module and the Mesh class which facilitate the functions
of the FreeCAD C++ Mesh-Kernel.


=== Creation and Loading ===
En primer lugar tienes que importar el módulo Malla:
To create an empty mesh object just use the standard constructor:
import Mesh


<syntaxhighlight>
Después de eso, ya tendrás acceso al módulo Malla y la clase Malla, que ofrecen las funciones del nucleo FreeCAD C++ Mesh-Kernel.
mesh = Mesh.Mesh()
</syntaxhighlight>


You can also create an object from a file


<syntaxhighlight>
=== Creación y Carga ===
mesh = Mesh.Mesh('D:/temp/Something.stl')
</syntaxhighlight>


(A list of compatible filetypes can be found under 'Meshes' [[Feature_list#IO|here]].)
Para crear un objeto malla vacío sólo tienes que utilizar el constructor estándar:
malla = Mesh.Mesh()
También puedes crear un objeto desde un archivo
malla = Mesh.Mesh ('D: / temp / Something.stl')
(Una lista de formatos de archivo compatibles se puede encontrar bajo 'Mallas' [[Feature_list/es#IO|aquí]].)


Or create it out of a set of triangles described by their corner points:


<syntaxhighlight>
O también puedes crear la malla a partir de un conjunto de triángulos descrito por sus vértices:
planarMesh = [
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
#triangle 2
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
]
planarMeshObject = Mesh.Mesh(planarMesh)
Mesh.show(planarMeshObject)
</syntaxhighlight>


The Mesh-Kernel takes care about creating a topological correct data structure by sorting
planarMesh = [
coincident points and edges together.
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
#triangle 2
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
]
planarMeshObject = Mesh.Mesh(planarMesh)


Later on you will see how you can test and examine mesh data.


=== Modeling ===
El núcleo de mallas, Mesh-Kernel, se encarga de crear una estructura topológica de datos correcta, ordenando conjuntamente los puntos coincidentes y los bordes.
To create regular geometries you can use the Python script BuildRegularGeoms.py.
Más adelante podrás ver cómo examinar y revisar los datos de la malla.


<syntaxhighlight>
=== Modelado ===
import BuildRegularGeoms
</syntaxhighlight>


This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube.
Para crear geometrías regulares puedes utilizar el script de Python BuildRegularGeoms.py.
To create a toroid, for instance, can be done as follows:
import BuildRegularGeoms
Esta secuencia de comandos proporciona métodos para definir cuerpos de revolución sencillos, como esferas, elipsoides, cilindros, toroides y conos. Y también tiene un método para crear un cubo simple.
Para crear un toroide, por ejemplo, se puede hacer de la siguiente manera:


<syntaxhighlight>
t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
m = Mesh.Mesh(t)
m = Mesh.Mesh(t)
</syntaxhighlight>


The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is.
The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.


<syntaxhighlight>
Los dos primeros parámetros definen los radios del toroide y el tercer parámetro es un factor de submuestreo relacionado con el número de triángulos que se han de crear. Cuanto mayor sea este valor, más suave es la forma y mejor acabado tiene el cuerpo.
m1, m2 # are the input mesh objects
m3 = Mesh.Mesh(m1) # create a copy of m1
m3.unite(m2) # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2) # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2) # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1) # the difference of m2 and m1, usually the result is different to m5
</syntaxhighlight>


Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.
m1, m2 # are the input mesh objects
m3 = Mesh.Mesh(m1) # create a copy of m1
m3.unite(m2) # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2) # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2) # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1) # the difference of m2 and m1, usually the result is different to m5


<syntaxhighlight>
import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
diff = sphere
diff = diff.difference(cylinder)
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.recompute()
</syntaxhighlight>


=== Examining and Testing ===
Por último, un ejemplo completo que calcula la intersección entre una esfera y un cilindro que corta a la esfera.


=== Write your own Algorithms ===
import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
diff = sphere
diff.difference(cylinder)
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.recompute()


=== Exporting ===
You can even write the mesh to a python module:


<syntaxhighlight>
=== Examen y pruebas ===
m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)
</syntaxhighlight>


=== Escribe tus propios algoritmos ===
=== Gui related stuff ===


=== Exportación ===
=== Odds and Ends ===
An extensive (though hard to use) source of Mesh related scripting are the unit test scripts of the Mesh-Module.
In this unit tests literally all methods are called and all properties/attributes are tweaked.
So if you are bold enough, take a look at the [http://free-cad.svn.sourceforge.net/viewvc/free-cad/trunk/src/Mod/Mesh/App/MeshTestsApp.py?view=markup Unit Test module].


{{docnav|FreeCAD Scripting Basics|Topological data scripting}}
Puedes incluso escribir la malla en un módulo de Python:


[[Category:Poweruser Documentation]]
m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
[[Category:Python Code]]
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)


{{clear}}
=== Interfaces gráficas de usuario relacionadas ===
<languages/>

=== Ajustes y pruebas ===
Una extensa, aunque dificil de usar, librería de archivos de guión relacionados con mallas son los scripts de prueba del módulo Malla.
En esta unidad, literalmente todos los métodos son invocados, y se ajustan todas las propiedades y atributos.
Así que si eres lo suficientemente audaz, echa un vistazo al [http://free-cad.svn.sourceforge.net/viewvc/free-cad/trunk/src/Mod/Mesh/App/MeshTestsApp.py?view=markup Módulo de prueba de unidades].




{{docnav/es|FreeCAD Scripting Basics/es|Topological data scripting/es}}

{{languages/es | {{en|Mesh Scripting}} {{fr|Mesh Scripting/fr}} {{it|Mesh Scripting/it}} {{ru|Mesh Scripting/ru}} {{se|Mesh Scripting/se}} }}

[[Category:Poweruser Documentation/es]]
[[Category:Python Code/es]]

Revision as of 19:23, 17 October 2014

Introduction

First of all you have to import the Mesh module:

import Mesh

After that you have access to the Mesh module and the Mesh class which facilitate the functions of the FreeCAD C++ Mesh-Kernel.

Creation and Loading

To create an empty mesh object just use the standard constructor:

mesh = Mesh.Mesh()

You can also create an object from a file

mesh = Mesh.Mesh('D:/temp/Something.stl')

(A list of compatible filetypes can be found under 'Meshes' here.)

Or create it out of a set of triangles described by their corner points:

planarMesh = [
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
#triangle 2
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
]
planarMeshObject = Mesh.Mesh(planarMesh)
Mesh.show(planarMeshObject)

The Mesh-Kernel takes care about creating a topological correct data structure by sorting coincident points and edges together.

Later on you will see how you can test and examine mesh data.

Modeling

To create regular geometries you can use the Python script BuildRegularGeoms.py.

import BuildRegularGeoms

This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube. To create a toroid, for instance, can be done as follows:

t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
m = Mesh.Mesh(t)

The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is. The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.

m1, m2              # are the input mesh objects
m3 = Mesh.Mesh(m1)  # create a copy of m1
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2)    # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2)   # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5

Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.

import Mesh, BuildRegularGeoms
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
diff = sphere
diff = diff.difference(cylinder)
d = FreeCAD.newDocument()
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
d.recompute()

Examining and Testing

Write your own Algorithms

Exporting

You can even write the mesh to a python module:

m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
import SavedMesh
m2 = Mesh.Mesh(SavedMesh.faces)

Gui related stuff

Odds and Ends

An extensive (though hard to use) source of Mesh related scripting are the unit test scripts of the Mesh-Module. In this unit tests literally all methods are called and all properties/attributes are tweaked. So if you are bold enough, take a look at the Unit Test module.

FreeCAD Scripting Basics
Topological data scripting